import { MaybeReduced, Reduced, Transducer } from "./types";
export declare function reduced<T>(result: T): Reduced<T>;
export declare function isReduced<T>(result: MaybeReduced<T>): result is Reduced<T>;
export declare function ensureReduced<T>(result: MaybeReduced<T>): Reduced<T>;
export declare function unreduced<T>(result: MaybeReduced<T>): T;
export declare function compose<T0>(): Transducer<T0, T0>;
export declare function compose<T0, T1>(f0: Transducer<T0, T1>): Transducer<T0, T1>;
export declare function compose<T0, T1, T2>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>): Transducer<T0, T2>;
export declare function compose<T0, T1, T2, T3>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>): Transducer<T0, T3>;
export declare function compose<T0, T1, T2, T3, T4>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>): Transducer<T0, T4>;
export declare function compose<T0, T1, T2, T3, T4, T5>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>, f4: Transducer<T4, T5>): Transducer<T0, T5>;
export declare function compose<T0, T1, T2, T3, T4, T5, T6>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>, f4: Transducer<T4, T5>, f5: Transducer<T5, T6>): Transducer<T0, T6>;
export declare function compose<T0, T1, T2, T3, T4, T5, T6, T7>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>, f4: Transducer<T4, T5>, f5: Transducer<T5, T6>, f6: Transducer<T6, T7>): Transducer<T0, T7>;
export declare function compose<T0, T1, T2, T3, T4, T5, T6, T7, T8>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>, f4: Transducer<T4, T5>, f5: Transducer<T5, T6>, f6: Transducer<T6, T7>, f7: Transducer<T7, T8>): Transducer<T0, T8>;
export declare function compose<T0, T1, T2, T3, T4, T5, T6, T7, T8>(f0: Transducer<T0, T1>, f1: Transducer<T1, T2>, f2: Transducer<T2, T3>, f3: Transducer<T3, T4>, f4: Transducer<T4, T5>, f5: Transducer<T5, T6>, f6: Transducer<T6, T7>, f7: Transducer<T7, T8>, ...rest: Array<Transducer<any, any>>): Transducer<T0, any>;
